//---------------------------------------------------------------------------

#ifndef uRunningLineH
#define uRunningLineH

#include <vcl.h>
#include <math.h>
#include <math.hpp>
//---------------------------------------------------------------------------


//-------------------------------------------------------------------------------
typedef struct _Horn
{
   TPoint p0;
   TPoint p1;
   TPoint p2;
}Horn;
typedef void(__fastcall (__closure *pf)(TObject *));

class _RunningLine : public TWinControl
{
private:
  enum pcCl{ccl0, ccl1, ccl2, cclNum};
  TColor m_aCl[cclNum];
  unsigned long long int m_iPhase;
  int m_iElpLen;
  int m_iLineWidth;
  pcCl m_clSlc;
  TCanvas *m_cvs;
  HDC m_hDC;
  HWND m_hWnd;
  bool m_bCC;
  TMemoryStream *m_Mem;
  TTimer *m_Timer;
  void __fastcall fnOnTime(TObject *Sender);
  void fnDraw();
  int fnDxPix(TPoint Pt0, TPoint Pt1, int iPicOfx, const int iElpLen);
  int fnDyPix(TPoint Pt0, TPoint Pt1, int iPicOfx, const int iElpLen);
  void fnSwop(int &ix, int &iy);

public:
  __fastcall _RunningLine(HWND hWnd);
  __fastcall virtual ~_RunningLine();
  void fnRunning();
  void fnStop();
  void fnSetDrawPt(TPoint *ppt, int iNum);
  void fnSetInterval(int iMsec);
  void fnSetElpLen(int iLen);
  void fnSetLineWidth(int iWidth);
};
//---------------------------------------------------------------------
extern void fn2DCoorRad(double du, double dv, double dDeg, double &dx, double &dy);
extern TPoint fnGetTriPt(TPoint ps, TPoint pe, float fAng);
extern _Horn fnGetHorn(TPoint ps, TPoint pe, float fAng);
extern void fnGetSnow(TPoint *Pt, int &iPtCnt, float fAng, int &iLv, bool bMult);
extern TPoint fnRadPt(TPoint pt, float fAng);
#endif
